ghc-7.8.4: The GHC API

Safe Haskell | None
Language | Haskell98

TcGenGenerics

# Documentation

canDoGenerics :: TyCon -> [Type] -> Maybe SDoc

canDoGenerics1 :: TyCon -> [Type] -> Maybe SDoc

data GenericKind

Constructors

Gen0 |
Gen1 |

data MetaTyCons

Instances

Outputable MetaTyCons |

genGenericMetaTyCons :: TyCon -> Module -> TcM (MetaTyCons, BagDerivStuff)

gen_Generic_binds :: GenericKind -> TyCon -> MetaTyCons -> Module -> TcM (LHsBinds RdrName, FamInst)

get_gen1_constrained_tys :: TyVar -> Type -> [Type]